<template>
  <div class="WAL position-relative bg-grey-4" :style="style">
    <q-dialog v-model="chooseContact">
      <q-card>
        <q-card-section>
          <div class="text-h6">Pilih User</div>
        </q-card-section>

        <q-card-section class="q-pt-none">

          <q-item clickable v-ripple v-for="kontakChat in kontak" @click="lihatChatDenganUser(kontakChat.id)">
            <q-item-section avatar>
              <q-avatar>
                <img :src="kontakChat.avatar || 'avatar.jpg'">
              </q-avatar>
            </q-item-section>
            <q-item-section>
              {{ kontakChat.name }}
              <q-item-label caption>{{ kontakChat.email }}</q-item-label>
            </q-item-section>
          </q-item>

        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="OK" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <q-layout view="lHh Lpr lFf" class="WAL__layout shadow-3" container>
      <q-header elevated>
        <q-toolbar class="bg-grey-3 text-black" v-if="chat.length !=0">
          <q-btn
            round
            flat
            icon="keyboard_arrow_left"
            class="WAL__drawer-open q-mr-sm"
            @click="leftDrawerOpen = true"
          />

          <q-btn round flat>
            <q-avatar>
              <img :src="currentConversation.penerima || 'avatar.jpg'">
            </q-avatar>
          </q-btn>

          <span class="q-subtitle-1 q-pl-md">
            {{ currentConversation.tujuan }}
          </span>

          <q-space/>

        </q-toolbar>
      </q-header>
      <q-drawer
        v-model="leftDrawerOpen"
        show-if-above
        bordered
        :breakpoint="690"
        :width="$q.screen.width"
      >
        <q-toolbar class="bg-grey-3">
          <img style="max-width: 10.53rem" src="~assets/t.png" />
          <q-space />
<!--          <q-btn round flat icon="edit" @click="chooseContact = true" />-->
<!--          <q-btn-->
<!--            round-->
<!--            flat-->
<!--            icon="close"-->
<!--            class="WAL__drawer-close"-->
<!--            @click="leftDrawerOpen = false"-->
<!--          />-->
        </q-toolbar>

        <q-toolbar class="bg-grey-2">
          <q-input rounded outlined dense class="WAL__field full-width" bg-color="white" v-model="search" placeholder="Search or start a new conversation">
            <template slot="prepend">
              <q-icon name="search" />
            </template>
          </q-input>
        </q-toolbar>

        <q-scroll-area style="height: calc(100% - 100px)">
          <q-list>
            <q-item
              v-for="(conversation, index) in room"
              :key="room.id"
              clickable
              v-ripple
              @click="lihatChat(index, conversation.id)"
            >
              <q-item-section avatar>
                <q-avatar>
                  <img :src="conversation.penerima || 'avatar.jpg'">
                </q-avatar>
              </q-item-section>

              <q-item-section>
                <q-item-label lines="1">
                  {{ conversation.tujuan }}
                </q-item-label>
                <q-item-label class="conversation__summary" caption>
                  <q-icon name="check" v-if="conversation.chatting.stamp" />
                  <q-icon name="not_interested" v-if="conversation.deleted" />
                  {{ conversation.chatting.stamp }}
                </q-item-label>
              </q-item-section>

              <q-item-section side>
                <q-item-label caption>
                  {{ conversation.time }}
                </q-item-label>
                <q-icon name="keyboard_arrow_down" />
              </q-item-section>
            </q-item>
          </q-list>
        </q-scroll-area>
      </q-drawer>
      <q-page-container class="bg-grey-2" v-if="chat.length !=0">
        <div class="q-pa-md row justify-center">
          <div style="  width: 100%; max-width: 400px">
            <div v-for="pesan in chatting">
              <q-chat-message
                name="me"
                :text="[pesan.message]"
                :stamp="pesan.stamp"
                sent
                bg-color="amber-7"
                v-if="user.id == pesan.user_id"
              />
              <q-chat-message
                :name="pesan.name"
                :text="[pesan.message]"
                :stamp="pesan.stamp"
                bg-color="green"
                v-if="user.id != pesan.user_id"
              />
            </div>
          </div>
        </div>
        <router-view />
      </q-page-container>
      <q-footer v-if="chat.length !=0">
        <q-toolbar class="bg-grey-3 text-black row" style="margin-bottom: 25px">
          <q-input rounded outlined dense class="WAL__field col-grow q-mr-sm" bg-color="white" v-model="message" placeholder="Tulis Pesan" />
          <q-btn round flat icon="send" @click="kirimPesan" />
        </q-toolbar>
      </q-footer>
    </q-layout>
  </div>
</template>

<script>
import { jarkonsPusher, jarkonsChannel } from "boot/pusher";
export default {
  name: 'WhatsappLayout',
  data () {
    return {
      leftDrawerOpen: true,
      search: '',
      message: '',
      room: [],
      chat: [],
      kontak: [],
      chooseContact: false,
      audioFiles: "alert.wav",
      currentConversationIndex: 0,
      conversations: [
        {
          id: 1,
          person: 'Razvan Stoenescu',
          avatar: 'https://cdn.quasar.dev/team/razvan_stoenescu.jpeg',
          caption: 'I\'m working on Quasar!',
          time: '15:00',
          sent: true
        },
        {
          id: 2,
          person: 'Dan Popescu',
          avatar: 'https://cdn.quasar.dev/team/dan_popescu.jpg',
          caption: 'I\'m working on Quasar!',
          time: '16:00',
          sent: true
        },
        {
          id: 3,
          person: 'Jeff Galbraith',
          avatar: 'https://cdn.quasar.dev/team/jeff_galbraith.jpg',
          caption: 'I\'m working on Quasar!',
          time: '18:00',
          sent: true
        },
        {
          id: 4,
          person: 'Allan Gaunt',
          avatar: 'https://cdn.quasar.dev/team/allan_gaunt.png',
          caption: 'I\'m working on Quasar!',
          time: '17:00',
          sent: true
        }
      ]
    }
  },

  beforeMount() {
    if (this.$q.platform.is.desktop) {
      this.$router.push("/chat")
    }

    jarkonsChannel.bind("chat-masuk", x => {
      let userId = x.message.kepada.user_id;

      console.log(x.message);

      if (this.user.id == userId) {
        this.$q.notify({
          message: `Ada Pesan Baru Dari, ${x.message.kepada.pengirim}`,
          position: "top-right",
          color: "green"
        })
        audioNotif.play();
      }

      if (this.currentConversation.id == x.message.room_id) {
        this.chat.data.push(x.message);
      }

    })
  },

  mounted() {

    const audioNotif = new Audio(this.audioFiles);

    this.loadRoom();
  },

  methods: {
    loadRoom: function () {
      this.$axios.post("/api/chat/list")
        .then(sukses => {
          this.room = sukses.data
        })

      this.$axios.get("/api/chat/user")
        .then(sukses => {
          this.kontak = sukses.data
        })
    },

    lihatChat: function (index, roomId) {
      this.message = null;
      this.$axios.post("api/chat/room/" + roomId)

        .then(sukses => {
          this.chat = sukses.data;
          this.leftDrawerOpen = false;
        })
      this.currentConversationIndex = index
    },

    kirimPesan: function () {
      let formData = new FormData();

      formData.append("to", this.currentConversation.penerima_id)
      formData.append("message", this.message)
      this.$q.loading.show();
      this.$axios.post("/api/chat/message", formData)
        .then(sukses => {
          this.$q.loading.hide();
          this.message = null;
        })

    },

    lihatChatDenganUser: function (userId) {
      let dataUser = new FormData();

      dataUser.append("to", userId);
      this.$q.loading.show();
      this.$axios.post("api/chat/room", dataUser)
        .then(sukses => {
          this.$q.loading.hide();
          this.chooseContact = false;
          let data = sukses.data

          let cari = this.room.filter(function (x) {
            return x.id == data.id
          })

          if (cari.length == 0) {
            this.room.push(data)
            this.currentConversationIndex = this.room.indexOf(data);
            this.lihatChat(this.currentConversationIndex, data.id)
          } else {
            this.currentConversationIndex = this.room.indexOf(cari[0]);
            this.lihatChat(this.currentConversationIndex, cari[0].id)
          }

        })
    },
  },

  computed: {
    currentConversation () {
      return this.room[this.currentConversationIndex]
    },
    user() {
      return this.$store.state.user.user;
    },
    style () {
      return {
        height: (parseInt(this.$q.screen.height) - 100) + 'px'
      }
    },
    chatting() {
      return this.chat.data.sort(function (a, b) {
        return a.id - b.id
      })
    },
  }
}
</script>

<style lang="sass">
.WAL
  width: 100%
  height: 100%
  padding-top: 20px
  padding-bottom: 20px
  &:before
    content: ''
    height: 127px
    position: fixed
    top: 0
    width: 100%
    background-color: #009688
  &__layout
    margin: 0 auto
    z-index: 0
    height: 100%
    width: 90%
    max-width: 950px
    border-radius: 5px
  &__field.q-field--outlined .q-field__control:before
    border: none
  .q-drawer--standard
    .WAL__drawer-close
      display: none
@media (max-width: 850px)
  .WAL
    padding: 0
    &__layout
      width: 100%
      border-radius: 0
@media (min-width: 691px)
  .WAL
    &__drawer-open
      display: none
.conversation__summary
  margin-top: 4px
.conversation__more
  margin-top: 0!important
  font-size: 1.4rem
</style>
